'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

const core = require('@babel/core');

function extractEnumValues(enumDecl) {
  const values = [];
  let lastIndex = -1;
  enumDecl.members.forEach(({
    initializer
  }) => {
    if (initializer) {
      if (core.types.isNumericLiteral(initializer)) {
        lastIndex = initializer.value;
        values.push(initializer.value);
      } else if (core.types.isStringLiteral(initializer)) {
        values.push(initializer.value);
      } else {// Skip
      }
    } else {
      lastIndex += 1;
      values.push(lastIndex);
    }
  });
  return values;
}

exports.extractEnumValues = extractEnumValues;
//# sourceMappingURL=extractEnumValues.js.map
